/************************
*  SPI minimal library  *
************************/

#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>  

#include "spi.h"

// Initialisation of SPI bus
void spi_init(unsigned char master)
{
if(master){
  SPI_DDR |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS);
  SPI_DDR &= ~(1<<SPI_MISO);
  }
else{
  SPI_DDR |= (1<<SPI_MISO);
  SPI_DDR &= (~(1<<SPI_MOSI))&(~(1<<SPI_SCK))&(~(1<<SPI_SS));
  }
if(master) SPCR |= (1<<MSTR);
SPCR |= (1<<SPE);
}

// Send and receive byte on SPI bus
uint8_t spi_exch(uint8_t output,uint8_t *input)
{
SPDR = output;
while(!(SPSR & (1<<SPIF)) && !(SPI_PIN & (1<<SPI_SS))); 
*input = SPDR;
return (SPI_PIN & (1<<SPI_SS))?0:1;
}
