/** TLC5947 LEDs driver **/

// Include files

#include <avr/io.h>

#include "tlc5947.h"

// Functions

void init_LED_Drivers(int nb){
                        // LED drivers I/O as outputs
  DDR_DLED |= (1<<PIN_DLED_CLOCK) | (1<<PIN_DLED_DATA) | (1<<PIN_DLED_LATCH);
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
}


void set_LED_Drivers(int pwm[],int nb){
  int c,b;
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
  // 24 channels per TLC5974
  for(c=DLED_CHANNELS*nb-1;c>=0;c--){
    // 12 bits per channel, send MSB first
    for(b=11;b>=0;b--){
                        // Set CLOCK output low
      PORT_DLED &= ~(1<<PIN_DLED_CLOCK);

                        // Set DATA as stated by bit #b of c
      if(pwm[c] & (1<<b))
        PORT_DLED |= (1<<PIN_DLED_DATA);
      else
        PORT_DLED &= ~(1<<PIN_DLED_DATA);

                        // Set CLOCK output HIGH
      PORT_DLED |= (1<<PIN_DLED_CLOCK);
    }
  }
                        // Set CLOCK output low
  PORT_DLED &= ~(1<<PIN_DLED_CLOCK);

                        // Set LATCH output high
  PORT_DLED |= (1<<PIN_DLED_LATCH);
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
}
